/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-groovy-sphero-node-0.1.2-0precise-20140906-1439/msg/SpheroCollision.msg
 *
 */


#ifndef SPHERO_NODE_MESSAGE_SPHEROCOLLISION_H
#define SPHERO_NODE_MESSAGE_SPHEROCOLLISION_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>

namespace sphero_node
{
template <class ContainerAllocator>
struct SpheroCollision_
{
  typedef SpheroCollision_<ContainerAllocator> Type;

  SpheroCollision_()
    : header()
    , x(0)
    , y(0)
    , z(0)
    , axis(0)
    , x_magnitude(0)
    , y_magnitude(0)
    , speed(0)
    , timestamp(0)  {
    }
  SpheroCollision_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , x(0)
    , y(0)
    , z(0)
    , axis(0)
    , x_magnitude(0)
    , y_magnitude(0)
    , speed(0)
    , timestamp(0)  {
    }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef int32_t _x_type;
  _x_type x;

   typedef int32_t _y_type;
  _y_type y;

   typedef int32_t _z_type;
  _z_type z;

   typedef int32_t _axis_type;
  _axis_type axis;

   typedef int32_t _x_magnitude_type;
  _x_magnitude_type x_magnitude;

   typedef int32_t _y_magnitude_type;
  _y_magnitude_type y_magnitude;

   typedef int32_t _speed_type;
  _speed_type speed;

   typedef int32_t _timestamp_type;
  _timestamp_type timestamp;




  typedef boost::shared_ptr< ::sphero_node::SpheroCollision_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::sphero_node::SpheroCollision_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct SpheroCollision_

typedef ::sphero_node::SpheroCollision_<std::allocator<void> > SpheroCollision;

typedef boost::shared_ptr< ::sphero_node::SpheroCollision > SpheroCollisionPtr;
typedef boost::shared_ptr< ::sphero_node::SpheroCollision const> SpheroCollisionConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::sphero_node::SpheroCollision_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::sphero_node::SpheroCollision_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace sphero_node

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': True}
// {'std_msgs': ['/opt/ros/groovy/share/std_msgs/cmake/../msg'], 'sphero_node': ['/tmp/buildd/ros-groovy-sphero-node-0.1.2-0precise-20140906-1439/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::sphero_node::SpheroCollision_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::sphero_node::SpheroCollision_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::sphero_node::SpheroCollision_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::sphero_node::SpheroCollision_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::sphero_node::SpheroCollision_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::sphero_node::SpheroCollision_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::sphero_node::SpheroCollision_<ContainerAllocator> >
{
  static const char* value()
  {
    return "35737f6e6824bac2c5d1f1b54f9c413c";
  }

  static const char* value(const ::sphero_node::SpheroCollision_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x35737f6e6824bac2ULL;
  static const uint64_t static_value2 = 0xc5d1f1b54f9c413cULL;
};

template<class ContainerAllocator>
struct DataType< ::sphero_node::SpheroCollision_<ContainerAllocator> >
{
  static const char* value()
  {
    return "sphero_node/SpheroCollision";
  }

  static const char* value(const ::sphero_node::SpheroCollision_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::sphero_node::SpheroCollision_<ContainerAllocator> >
{
  static const char* value()
  {
    return "std_msgs/Header header\n\
int32 x\n\
int32 y\n\
int32 z\n\
int32 axis\n\
int32 x_magnitude\n\
int32 y_magnitude \n\
int32 speed\n\
int32 timestamp\n\
\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
";
  }

  static const char* value(const ::sphero_node::SpheroCollision_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::sphero_node::SpheroCollision_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.x);
      stream.next(m.y);
      stream.next(m.z);
      stream.next(m.axis);
      stream.next(m.x_magnitude);
      stream.next(m.y_magnitude);
      stream.next(m.speed);
      stream.next(m.timestamp);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct SpheroCollision_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::sphero_node::SpheroCollision_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::sphero_node::SpheroCollision_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "x: ";
    Printer<int32_t>::stream(s, indent + "  ", v.x);
    s << indent << "y: ";
    Printer<int32_t>::stream(s, indent + "  ", v.y);
    s << indent << "z: ";
    Printer<int32_t>::stream(s, indent + "  ", v.z);
    s << indent << "axis: ";
    Printer<int32_t>::stream(s, indent + "  ", v.axis);
    s << indent << "x_magnitude: ";
    Printer<int32_t>::stream(s, indent + "  ", v.x_magnitude);
    s << indent << "y_magnitude: ";
    Printer<int32_t>::stream(s, indent + "  ", v.y_magnitude);
    s << indent << "speed: ";
    Printer<int32_t>::stream(s, indent + "  ", v.speed);
    s << indent << "timestamp: ";
    Printer<int32_t>::stream(s, indent + "  ", v.timestamp);
  }
};

} // namespace message_operations
} // namespace ros

#endif // SPHERO_NODE_MESSAGE_SPHEROCOLLISION_H
